package com.ted.controller;

import org.opensaml.saml2.core.Assertion;
import org.opensaml.saml2.core.NameID;
import org.opensaml.xml.schema.XSString;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class SSOController {

	private static final Logger logger = LoggerFactory.getLogger(SSOController.class);

	@RequestMapping("/")
	public String index(Model model) {

		logger.info("Request from Okta");

		Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
		NameID nameId = (NameID) authentication.getPrincipal();
		model.addAttribute("name", nameId.getValue());
		
		logger.info("Logged in user ", nameId.getValue());
/*
		// there be dragons
		Assertion assertion = (Assertion) nameId.getParent().getParent();
		assertion.getAttributeStatements().forEach(attributeStatement -> {
			attributeStatement.getAttributes().forEach(attribute -> {
				String key = attribute.getName();
				// cheat a little to not deal with an array/list value
				String value = ((XSString) attribute.getAttributeValues().get(0)).getValue();
				model.addAttribute(key, value);
			});
		});
*/
		return "index";
	}

}
